//+------------------------------------------------------------------+
//|                                   MultiPairProfitLossControl.mq4 |
//|                                                         Mandarox |
//|                                                                  |
//| This EA is written by me for controling profit/loss              |
//| on multiple currencies.                                          |
//| All values are in money, not in pips.                            |
//+------------------------------------------------------------------+
#property copyright "Mandarox"
#property link      ""

extern int MagicNumber = 642342; //of the MultiPairEA
extern double MaxLossMoney = 200.0; //Global
extern double MaxProfitMoney = 50.0; //Global

extern double MinLossMoneyPerTrade = 5.0; //Trades would only be closed, if the have a min loss
extern double MaxLossMoneyPerTrade = 50.0; //Trade would be closed than, even if global loss isn't reached

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

  int total = OrdersTotal();
  int order;
  double GlobalPL=0;
  for(order=total-1; order>=0; order--)
  {
    OrderSelect(order, SELECT_BY_POS);
    if (OrderMagicNumber()==MagicNumber)
    {
      GlobalPL+=OrderProfit();
    }
  }

  for(order=total-1; order>=0; order--)
  {
    OrderSelect(order, SELECT_BY_POS);
    if (OrderMagicNumber()==MagicNumber)
    {
      double profit = OrderProfit();
      bool close = false;

      //GlobalProfit reached --> Close all
      if (GlobalPL>=MaxProfitMoney) close=true;
      
      //MaxLossPerTrade
      if(profit<MaxLossMoneyPerTrade*(-1)) close=true;
      
      //MaxLossGlobal reached --> Close only loss trades with min loss. Other trades could grow.
      if(GlobalPL < MaxLossMoney*(-1) && profit<MinLossMoneyPerTrade*(-1)) close=true;

      if(close)
      {
        OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5);
      }
    }
  }

//----
   return(0);
  }
//+------------------------------------------------------------------+